# -*- coding: utf-8 -*-
"""
Created on Thu Nov 23 19:11:46 2023

@author: USER
"""

import numpy as np
import matplotlib.pyplot as mpl
PI=3.1415926

impdata= np.genfromtxt(r"Sample Potentiostatic EIS.dta", dtype = [('Pt',int),('Time',float),('Freq',float),('Zreal',float),('Zimag',float),('Zsig',float),('Zmod',float),('Zphz',float),('Idc',float),('Vdc',float),('IERange',int)],skip_header=98)
imarray=impdata['Zimag']
freqarray= impdata['Freq']
downsample=1 # 1 uses 10 time constants per decade, whereas 10 would use 1 time constant

Tcarray=np.zeros(int(len(freqarray)/downsample))
dfreqarray=np.zeros(int(len(freqarray)/downsample))
dimarray=np.zeros(int(len(freqarray)/downsample))
Zresol=np.zeros(len(freqarray))


for i in range(len(Tcarray)):
    Tcarray[i]=1.0/(2*PI*freqarray[i*downsample])
    dfreqarray[i] = 2*PI*freqarray[i*downsample]
    dimarray[i]=imarray[i*downsample]

matrix=np.zeros(shape=(len(Tcarray),len(dfreqarray)))

for i in range(len(Tcarray)):
    for j in range(len(dfreqarray)):
        matrix[i,j]=dfreqarray[j]*Tcarray[i]/(1+(dfreqarray[j]*Tcarray[i])**2)
        
Rk=np.linalg.solve(matrix, dimarray)

for i in range(len(freqarray)):
    for k in range(len(Tcarray)):
        Zresol[i]=Zresol[i]+Rk[k]/(1+(Tcarray[k]*2*PI*freqarray[i])**2)
mpl.subplot(311)
mpl.semilogx(freqarray,-1*Zresol+np.average(impdata['Zreal']+Zresol), marker='o',label='calculation')
mpl.semilogx(freqarray,impdata['Zreal'], marker='x',label='measurement')
mpl.ylabel("Z'")
mpl.legend()
mpl.subplot(312)
mpl.semilogx(freqarray,(impdata['Zreal']+Zresol-np.average(impdata['Zreal']+Zresol))/impdata['Zreal'], marker='o',label='residual')
mpl.legend()
mpl.subplot(313)
mpl.semilogx(Tcarray,-Rk, marker='o',label='Rk')
mpl.legend()
mpl.show() 